import cafe.CafeQueue;
import cafe.CustomerType;
import cafe.ServerThread;
import cafe.CustomerThread;

/**
 * This program runs threads in parallel.
 */
public class Simulation 
{
	private static final int CAFE_CAPACITY = 3;
	
    public static void main(String[] args) 
    {
        CafeQueue cafe = new CafeQueue(CAFE_CAPACITY);
        
        final int COFFEE_DOORS = 3;
        final int COFFEE_COUNT = 5;
        final int BURGER_COUNT = 5;
        
        // Create Runnable objects.
        Runnable run1 = new CustomerThread(CustomerType.COFFEE,
                                     cafe, 1, COFFEE_COUNT);
        Runnable run2 = new CustomerThread(CustomerType.COFFEE,
                                     cafe, 2, COFFEE_COUNT);
        Runnable run3 = new CustomerThread(CustomerType.COFFEE,
                                     cafe, 3, COFFEE_COUNT);
        Runnable run4 = new CustomerThread(CustomerType.BURGER,
                                     cafe, 4, BURGER_COUNT);
        Runnable run5 = new ServerThread(cafe, COFFEE_DOORS*COFFEE_COUNT + BURGER_COUNT);

        // Create threads.
        Thread thread1 = new Thread(run1);
        Thread thread2 = new Thread(run2);
        Thread thread3 = new Thread(run3);
        Thread thread4 = new Thread(run4);
        Thread thread5 = new Thread(run5);

        // Start threads.
        thread1.start();
        thread2.start();
        thread3.start();
        thread4.start();
        thread5.start();
    }
}
