package cafe;
/**
 * A customer of the cafe.
 */
public class Customer 
{
    private CustomerType type;  // COFFEE or BURGER
    private int door;           // the cafe door the patron used
    private int sequence;       // sequence number per door
    
    // Getters.
    public CustomerType getType() { return type; }
    public int          getDoor() { return door; }
    
    /**
     * Constructor.
     * @param type the type of customer (COFFEE or BURGER).
     * @param door the entrance door.
     * @param sequence the sequence number (per door).
     */
    public Customer(CustomerType type, int door, int sequence)
    {
        this.type = type;
        this.door = door;
        this.sequence = sequence;
    }
    
    /**
     * Negate the sequence number for printing by the server thread.
     */
    public void negateSequence() { sequence = -sequence; }
    
    @Override
    public String toString()
    {
        StringBuilder sb = new StringBuilder();
        for (int i = 1; i < door; i++) sb.append("\t\t");
        sb.append(String.format("%4d: %s", sequence, type));
        return sb.toString();
    }
}
