package cafe;

/**
 * The type of cafe customer.
 */
public enum CustomerType 
{
	COFFEE(1, 2),  // arrive up to 1 minute  apart, serve time up to 2 minutes
	BURGER(5, 5);  // arrive up to 5 minutes apart, serve time up to 5 minutes
	
	private int maxArriveTime;  // inter-arrival time
	private int maxServeTime;   // serve time
	
	/**
	 * Private constructor.
	 * For the simulation, 1 second of simulation time = 1 minute of real time.
	 * @param maxArriveTime the maximum inter-arrival time (in seconds)
	 * @param maxServeTime  the maximum service time (in seconds)
	 */
	private CustomerType(int maxArriveTime, int maxServeTime)
	{
		this.maxArriveTime = maxArriveTime;
		this.maxServeTime  = maxServeTime;
	}
	
	// Getters.
	public int getMaxArriveTime() { return maxArriveTime; }
	public int getMaxServeTime()  { return maxServeTime; }
}
